/***************************************************************************
                          gifplayer.cpp  -  description
                             -------------------
    begin                : Don Mai 25 12:45:54 MEST 2000
    copyright            : (C) 2000 by Helmut Fahrion
    email                : hefa@bitctrl.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "gifplayer.h"

Gifplayer::Gifplayer (QWidget * parent, const char *name):
QWidget (parent, name)
{
  setBackgroundColor (black);

  (void *) paint = (void *) gd = NULL;
  dateiname[0] = 0;

  paint = new QPainter (this);

  if (!paint)
    {
      cerr << "kein Painter!\n";
      exit (-1);
    }

}

Gifplayer::~Gifplayer ()
{
  if (gd)
    delete gd;
  if (paint)
    delete paint;
}

void
Gifplayer::lesegif (int argc, char *argv[])
{
  int x, run, v = dateiname[0] = eloop = picture = newtime = 0;

  for (run = 1; run != 0;)
    {
      switch ((x = getopt (argc, argv, "p:t:d:vVh?ls")))
	{
	case 'h':
	case '?':
	  cout << "\ngipflayer [-v|V] [-h|?] [t] [-d] dateiname.gif\n"
	    << "-v: Verbose Mode, gibt alle Datenrecords aus.\n"
	    << "-V: Wie -v aber es werden auch die Bildarrays ausgegeben.\n"
	    << "-h oder -?: diese Hilfe.\n"
	    << "-t gibt eine neue Wartezeit zwischen den Einzelbildern an\n"
	    << "-d dateiname.gif: Name der anzuzeigenden Gif Datei\n"
	    << "dateiname.gif: Name der anzuzeigenden Gif Datei\n"
	    << "viel Spa beim anzeigern der Gif's!\n"
	    << "Helmut.\nhefa@bitctrl.de\n";
	  break;
	case 'd':
	  strncpy (dateiname, optarg, 80);
	  gd = new gifdecode (dateiname, v, newtime, picture, eloop);
	  break;
	case 't':
	  newtime = atoi (optarg);	// neue Zeitangabe fr Animation
	  break;
	case 'p':
	  picture = atoi (optarg);	// Einzelbildanzeige
	  break;
	case 'l':
	  eloop = 1;		// Endlos Schleife
	  break;
	case 'v':
	  v = 1;		// verbose 1 on
	  break;
	case 'V':
	  v = 2;		// Verbose 2 on
	  break;
	case -1:
	  if (optind < argc)
	    {
	      strcpy (dateiname, argv[optind++]);
	      gd = new gifdecode (dateiname, v, newtime, picture, eloop);
	    }
	  run = 0;
	  break;
	default:
	  //fprintf (stderr, "unbekannte Option!\n");
	  cerr << "unbekannte Option!\n"
	    << "bitte gipflayer [-h|?] aufrufen.\n";
	}
    }


}

void
Gifplayer::paintEvent (QPaintEvent *)
{
  // und los...
  gd->showgif ((void *) paint, (void *) this);
}
